/* Auto-generated, do not edit.
 *
 * This file may be distributed under the same terms
 * as the specification from which it was generated.
 */

/**
 * RTCOM_TP_HASH_TYPE_CONTACT_INFO_MAP:
 *
 * A dictionary whose keys are contact handles and whose         values are contact information..
 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GHashTable
 * appropriate for representing a D-Bus
 * dictionary of signature
 * <literal>a{ua(sasas)}</literal>.
 *
 * Keys (D-Bus type <literal>u</literal>,
 * type <literal>Contact_Handle</literal>,
 * named <literal>Handle</literal>):
 * (Undocumented)
 *
 * Values (D-Bus type <literal>a(sasas)</literal>,
 * type <literal>Contact_Info_Field[]</literal>,
 * named <literal>Contact_Info</literal>):
 * (Undocumented)
 *
 */
#define RTCOM_TP_HASH_TYPE_CONTACT_INFO_MAP (rtcom_tp_type_dbus_hash_ua_28sasas_29 ())

/**
 * RTCOM_TP_HASH_TYPE_CONTACT_SEARCH_MAP:
 *
 * A map from search keys to search terms.
 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GHashTable
 * appropriate for representing a D-Bus
 * dictionary of signature
 * <literal>a{ss}</literal>.
 *
 * Keys (D-Bus type <literal>s</literal>,
 * type <literal>Contact_Search_Key</literal>,
 * named <literal>Key</literal>):
 * The search key to match against
 *
 * Values (D-Bus type <literal>s</literal>,
 * named <literal>Term</literal>):
 * The term or terms to be searched for in the search key; depending on           the protocol and the server implementation, this may be matched by           exact or approximate equality, substring matching, word matching           or any other matching algorithm
 *
 */
#define RTCOM_TP_HASH_TYPE_CONTACT_SEARCH_MAP (rtcom_tp_type_dbus_hash_ss ())

/**
 * RTCOM_TP_HASH_TYPE_STREAM_DIAL_STRING_MAP:
 *
 * A map from stream IDs to dial strings.
 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GHashTable
 * appropriate for representing a D-Bus
 * dictionary of signature
 * <literal>a{us}</literal>.
 *
 * Keys (D-Bus type <literal>u</literal>,
 * type <literal>Stream_ID</literal>,
 * named <literal>Stream_ID</literal>):
 * The ID of a stream currently sending a dial string
 *
 * Values (D-Bus type <literal>s</literal>,
 * type <literal>Dial_String</literal>,
 * named <literal>Dial_String</literal>):
 * The dial string being sent, or the empty string if           unknown
 *
 */
#define RTCOM_TP_HASH_TYPE_STREAM_DIAL_STRING_MAP (rtcom_tp_type_dbus_hash_us ())

/**
 * RTCOM_TP_HASH_TYPE_MESSAGE_PART:
 *
 * &lt;tp:docstring xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;         &lt;p&gt;Part of a message&apos;s content. In practice, this mapping never           appears in isolation - messages are represented by a list of           &lt;tp:type&gt;Message_Part&lt;/tp:type&gt; mappings.&lt;/p&gt;          &lt;p&gt;An example of how a message might           look, in a Python-like syntax:&lt;/p&gt;            &lt;pre&gt; [   {     &apos;message-token&apos;: &apos;9de9546a-3400-4419-a505-3ea270cb834c&apos;,     &apos;message-sender&apos;: 42,     &apos;message-sent&apos;: 1210067943,     &apos;message-received&apos;: 1210067947,     &apos;message-type&apos;: 0,              # = Channel_Text_Message_Type_Normal     &apos;pending-message-id&apos;: 437,   },   { &apos;alternative&apos;: &apos;main&apos;,     &apos;content-type&apos;: &apos;text/html&apos;,     &apos;content&apos;: &apos;Here is a photo of my cat:&amp;lt;br /&amp;gt;&apos; +                &apos;&amp;lt;img src=&amp;quot;cid:catphoto&amp;quot; alt=&amp;quot;lol!&amp;quot; /&amp;gt;&apos; +                &apos;&amp;lt;br /&amp;gt;Isn&apos;t it cute?&apos;,   },   { &apos;alternative&apos;: &apos;main&apos;,     &apos;content-type&apos;: &apos;text/plain&apos;,     &apos;content&apos;: &apos;Here is a photo of my cat:\n[IMG: lol!]\nIsn&apos;t it cute?&apos;,   },   { &apos;identifier&apos;: &apos;catphoto&apos;,     &apos;content-type&apos;: &apos;image/jpeg&apos;,     &apos;size&apos;: 101000,     &apos;needs-retrieval&apos;: True,   }, ]           &lt;/pre&gt;          &lt;div&gt;           &lt;p&gt;The first part of the message contains &amp;quot;headers&amp;quot; which refer             to the entire message.&lt;/p&gt;            &lt;p&gt;It is an error for a connection manager to put keys referring             to the message as a whole in the second or subsequent             Message_Part, but clients MUST recover from this error by ignoring             these keys in the second and subsequent parts.&lt;/p&gt;            &lt;tp:rationale&gt;             &lt;p&gt;Instead of representing messages as aa{sv} where the first               dictionary is special (a dictionary of headers), we could have               used a signature like (a{sv}aa{sv}) to separate out the headers               and the body parts.&lt;/p&gt;              &lt;p&gt;However, this would make access to the messages more awkward.               In Python, the syntax for access to a header field would remain               &lt;code&gt;message[0][&apos;message-type&apos;]&lt;/code&gt;, but access to a body               field in the second body part would change from               message[2][&apos;content&apos;] to message[1][1][&apos;content&apos;]. In GLib,               the message would change from being a               GPtrArray(GHashTable) to being a               GValueArray(GHashTable, GPtrArray(GHashTable)) which is rather               inconvenient to dereference.&lt;/p&gt;           &lt;/tp:rationale&gt;            &lt;p&gt;Well-known keys for the message as a whole, and the corresponding             value types, include:&lt;/p&gt;            &lt;dl&gt;             &lt;dt&gt;message-token (s)&lt;/dt&gt;             &lt;dd&gt;An opaque, globally-unique identifier for the entire message.               This MAY be treated as if it were a MIME Message-ID, e.g. for               the mid: and cid: URI schemes. If omitted, there is no suitable               token.&lt;/dd&gt;              &lt;dt&gt;message-sent (x - &lt;tp:type&gt;Unix_Timestamp64&lt;/tp:type&gt;)&lt;/dt&gt;             &lt;dd&gt;The time the message was sent (if unavailable, the time               it arrived at a central server MAY be used). Omitted if no               reasonable approximation is available; SHOULD always be present               on outgoing messages.&lt;/dd&gt;              &lt;dt&gt;message-received (x - &lt;tp:type&gt;Unix_Timestamp64&lt;/tp:type&gt;)&lt;/dt&gt;             &lt;dd&gt;The time the message was received locally. SHOULD always               be present.&lt;/dd&gt;              &lt;dt&gt;message-sender (u - &lt;tp:type&gt;Contact_Handle&lt;/tp:type&gt;)&lt;/dt&gt;             &lt;dd&gt;The contact who sent the message. If 0 or omitted, the contact               who sent the message could not be determined.&lt;/dd&gt;              &lt;dt&gt;message-type (u - &lt;tp:type&gt;Channel_Text_Message_Type&lt;/tp:type&gt;)             &lt;/dt&gt;             &lt;dd&gt;The type of message; if omitted,               Channel_Text_Message_Type_Normal MUST be assumed. MAY               be omitted for normal chat messages.&lt;/dd&gt;              &lt;dt&gt;pending-message-id (u - &lt;tp:type&gt;Message_ID&lt;/tp:type&gt;)&lt;/dt&gt;             &lt;dd&gt;The incoming message ID. This MUST NOT be present on outgoing               messages. Clients SHOULD NOT store this key - it is only valid               for as long as the message remains unacknowledged.&lt;/dd&gt;              &lt;dt&gt;interface (s - &lt;tp:type&gt;DBus_Interface&lt;/tp:type&gt;)&lt;/dt&gt;             &lt;dd&gt;This message is specific to the given interface, which is               neither Text nor Messages. It SHOULD be ignored if that               interface is not supported. (Note that an &apos;interface&apos; key               can also appear on the second and subsequent parts, where               it indicates that that part (only) should be ignored if               unsupported.)&lt;/dd&gt;              &lt;dt&gt;scrollback (b)&lt;/dt&gt;             &lt;dd&gt;If present and true, the incoming message was part of a               replay of message history (this matches the Scrollback flag in               &lt;tp:type&gt;Channel_Text_Message_Flags&lt;/tp:type&gt;). This flag               does not make sense on outgoing messages and SHOULD NOT               appear there.&lt;/dd&gt;              &lt;dt&gt;rescued (b)&lt;/dt&gt;             &lt;dd&gt;If present and true, the incoming message has been seen in               a previous channel during the lifetime of the Connection,               but had not been acknowledged when that channel closed, causing               an identical channel (in which the message now appears) to open.               This matches the Rescued flag in               &lt;tp:type&gt;Channel_Text_Message_Flags&lt;/tp:type&gt;; it               does not make sense on outgoing messages, and SHOULD NOT               appear there.&lt;/dd&gt;           &lt;/dl&gt;         &lt;/div&gt;          &lt;div&gt;           &lt;p&gt;The second and subsequent parts contain the message&apos;s             content, including plain text, formatted text and/or attached             files.&lt;/p&gt;            &lt;p&gt;It is an error for a connection manager to put keys referring             to the message body in the first Message_Part;             clients MUST recover from this error by ignoring             these keys in first part.&lt;/p&gt;            &lt;p&gt;In any group of parts with the same non-empty value for the             &amp;quot;alternative&amp;quot; key (which represent alternative versions of the             same content), more faithful versions of the intended message MUST             come before less faithful versions (note that this order is the             opposite of MIME &amp;quot;multipart/alternative&amp;quot; parts). Clients SHOULD             display the first alternative that they understand.&lt;/p&gt;            &lt;tp:rationale&gt;             &lt;p&gt;Specifying the preference order means that if the underlying               protocol doesn&apos;t support alternatives, the CM can safely delete               everything apart from the first supported alternative when               sending messages.&lt;/p&gt;              &lt;p&gt;The order is the reverse of MIME because MIME&apos;s rationale for               placing the &amp;quot;plainest&amp;quot; part first (legibility in pre-MIME UAs)               does not apply to us, and placing the most preferred part               first simplifies display (a client can iterate the message               in order, display the first alternative that it understands,               and skip displaying all subsequent parts with the same               &amp;quot;alternative&amp;quot; key).&lt;/p&gt;           &lt;/tp:rationale&gt;            &lt;p&gt;Clients SHOULD present all parts that are not redundant             alternatives in the order they appear in this array, possibly             excluding parts that are referenced by another displayed part.             It is implementation-specific how the parts are presented to the             user.&lt;/p&gt;            &lt;tp:rationale&gt;             &lt;p&gt;This allows CMs to assume that all parts are actually shown to               the user, even if they are not explicitly referenced - we do               not yet recommend formatted text, and there is no way for               plain text to reference an attachment since it has no concept of               markup or references. This also forces clients to do something               sensible with messages that consist entirely of &amp;quot;attachments&amp;quot;,               with no &amp;quot;body&amp;quot; at all.&lt;/p&gt;              &lt;p&gt;For instance, when displaying the above example, a client that               understands the HTML part should display the JPEG image once,               between the two lines &amp;quot;Here is a photo of my cat:&amp;quot; and               &amp;quot;Isn&apos;t it cute?&amp;quot;; it may additionally present the image in some               way for a second time, after &amp;quot;Isn&apos;t it cute?&amp;quot;, or may choose               not to.&lt;/p&gt;              &lt;p&gt;A client that does not understand HTML, displaying the same               message, should display the plain-text part, followed by the JPEG               image.&lt;/p&gt;           &lt;/tp:rationale&gt;            &lt;p&gt;Well-known keys for the second and subsequent parts, and the             corresponding value types, include:&lt;/p&gt;            &lt;dl&gt;             &lt;dt&gt;identifier (s)&lt;/dt&gt;             &lt;dd&gt;An opaque identifier for this part.               Parts of a message MAY reference other parts by treating               this identifier as if it were a MIME Content-ID and using               the cid: URI scheme.&lt;/dd&gt;              &lt;dt&gt;alternative (s)&lt;/dt&gt;             &lt;dd&gt;               &lt;p&gt;If present, this part of the message is an alternative for                 all other parts with the same value for &amp;quot;alternative&amp;quot;.                 Clients SHOULD only display one of them (this is expected to                 be used for XHTML messages in a future version of this                 specification).&lt;/p&gt;                &lt;p&gt;If omitted, this part is not an alternative for any other                 part.&lt;/p&gt;                &lt;p&gt;Parts of a message MAY reference the group of alternatives                 as a whole (i.e. a reference to whichever of them is chosen)                 by treating this identifier as if it were the MIME Content-ID                 of a multipart/alternative part, and using the cid: URI                 scheme.&lt;/p&gt;             &lt;/dd&gt;              &lt;dt&gt;content-type (s)&lt;/dt&gt;             &lt;dd&gt;               &lt;p&gt;The MIME type of this part. See the documentation                 for ReceivedMessage for notes on the special status of                 &amp;quot;text/plain&amp;quot; parts.&lt;/p&gt;                &lt;p&gt;Connection managers MUST NOT signal parts without a                 &apos;content-type&apos; key; if a protocol provides no way to determine                 the MIME type, the connection manager is responsible for                 guessing it, but MAY fall back to &amp;quot;text/plain&amp;quot; for text and                 &amp;quot;application/octet-stream&amp;quot; for non-text.&lt;/p&gt;                &lt;p&gt;Clients MUST ignore parts without a &apos;content-type&apos; key, which                 are reserved for future expansion.&lt;/p&gt;             &lt;/dd&gt;              &lt;dt&gt;lang (s)&lt;/dt&gt;             &lt;dd&gt;The natural language of this part, identified by a               RFC 3066 language tag.                &lt;tp:rationale&gt;                 XMPP allows alternative-selection by language as well as                 by content-type.               &lt;/tp:rationale&gt;             &lt;/dd&gt;              &lt;dt&gt;size (u)&lt;/dt&gt;             &lt;dd&gt;The size in bytes (if needs-retrieval is true, this MAY be an               estimated or approximate size). SHOULD be omitted if &apos;content&apos;               is provided.                &lt;tp:rationale&gt;                 There&apos;s no point in providing the size if you&apos;re already                 providing all the content.               &lt;/tp:rationale&gt;               &lt;/dd&gt;              &lt;dt&gt;needs-retrieval (b)&lt;/dt&gt;             &lt;dd&gt;If false or omitted, the connection               manager already holds this part in memory. If present and true,               this part will be retrieved on demand (like MIME&apos;s               message/external-body), so clients should expect retrieval to               take time; if this specification is later extended to provide a               streaming version of GetPendingMessageContent, clients should               use it for parts with this flag.&lt;/dd&gt;              &lt;dt&gt;truncated (b)&lt;/dt&gt;             &lt;dd&gt;The content available via the &apos;content&apos; key or               GetPendingMessageContent has been truncated by the server               or connection manager (equivalent to               Channel_Text_Message_Flag_Truncated in the Text interface).             &lt;/dd&gt;              &lt;dt&gt;content (s or ay)&lt;/dt&gt;             &lt;dd&gt;The part&apos;s content, if it is available and               sufficiently small to include here (implies that               &apos;needs-retrieval&apos; is false or omitted). Otherwise, omitted.               If the part is human-readable text or HTML, the value for this               key MUST be a UTF-8 string (D-Bus signature &apos;s&apos;).               If the part is not text, the value MUST be a byte-array               (D-Bus signature &apos;ay&apos;). If the part is a text-based format               that is not the main body of the message (e.g. an iCalendar               or an attached XML document), the value SHOULD be a UTF-8 string,               transcoding from another charset to UTF-8 if necessary, but               MAY be a byte-array (of unspecified character set) if               transcoding fails or the source charset is not known.&lt;/dd&gt;                &lt;!-- FIXME: &quot;sufficiently small to include&quot; is not currently               defined; we should add some API so clients can tell the                 CM how large a message it should emit in the signal.--&gt;              &lt;dt&gt;interface (s - &lt;tp:type&gt;DBus_Interface&lt;/tp:type&gt;)&lt;/dt&gt;             &lt;dd&gt;This part is specific to the given interface, which is               neither Text nor Messages. It SHOULD be ignored if that               interface is not supported. (Note that an &apos;interface&apos; key               can also appear on the first part, where it indicates that the               entire message should be ignored if unsupported.)&lt;/dd&gt;           &lt;/dl&gt;          &lt;/div&gt;           &lt;div&gt;           &lt;p&gt;Delivery reports are also represented as messages, of type             Channel_Text_Message_Type_Delivery_Report, with the             Non_Text_Content flag in the Text interface.&lt;/p&gt;            &lt;p&gt;Whenever a message of type             Channel_Text_Message_Type_Delivery_Report is signalled for a             delivery error report, Channel.Type.Text.SendError SHOULD also             be emitted; whenever Channel.Type.Text.SendError is emitted by a             channel which supports this interface, a message of type             Channel_Text_Message_Type_Delivery_Report MUST also be emitted.&lt;/p&gt;            &lt;p&gt;The corresponding message in the Messages interface MUST contain             &amp;quot;headers&amp;quot; for the delivery report, as specified below, in its             first Message_Part.&lt;/p&gt;            &lt;dl&gt;             &lt;dt&gt;message-sender (u - Contact_Handle as defined above)&lt;/dt&gt;             &lt;dd&gt;MUST be the intended recipient of the original message, if               available (zero or omitted if the intended recipient is               unavailable or is not a contact, e.g. a chatroom), even if the               delivery report actually came from an intermediate server.&lt;/dd&gt;              &lt;dt&gt;message-type (u - Channel_Text_Message_Type as defined               above)&lt;/dt&gt;             &lt;dd&gt;MUST be Channel_Text_Message_Type_Delivery_Report.&lt;/dd&gt;              &lt;dt&gt;delivery-status (u - Delivery_Status)&lt;/dt&gt;             &lt;dd&gt;The status of the message. All delivery reports MUST contain               this key in the first Message_Part.&lt;/dd&gt;              &lt;dt&gt;delivery-token (s - Sent_Message_Token)&lt;/dt&gt;              &lt;dd&gt;               &lt;p&gt;An identifier for the message to which this delivery report                 refers. MUST NOT be an empty string. Omitted if not                 available.&lt;/p&gt;                &lt;p&gt;Clients may match this against the token produced by the                 SendMessage method and MessageSent signal. A status report                 with no token could match any sent message, and a sent                 message with an empty token could match any status report.                 If multiple sent messages match, clients SHOULD use some                 reasonable heuristic.&lt;/p&gt;                &lt;tp:rationale&gt;                 In an ideal world, we could unambiguously match reports                 against messages; however, deployed protocols are not ideal,                 and not all reports and messages can be matched.               &lt;/tp:rationale&gt;             &lt;/dd&gt;              &lt;dt&gt;delivery-error (u - Channel_Text_Send_Error)&lt;/dt&gt;             &lt;dd&gt;               The reason for the failure. MUST be omitted if this was a               successful delivery; SHOULD be omitted if it would be               Channel_Text_Send_Error_Unknown.             &lt;/dd&gt;              &lt;dt&gt;delivery-dbus-error (s - DBus_Error_Name)&lt;/dt&gt;             &lt;dd&gt;               The reason for the failure, specified as a (possibly               implementation-specific) D-Bus error. MUST be omitted if this was               a successful delivery. If set, the &apos;delivery-error&apos; key SHOULD be               set to the closest available value.             &lt;/dd&gt;              &lt;dt&gt;delivery-error-message (s)&lt;/dt&gt;             &lt;dd&gt;               Debugging information on why the message could not be delivered.               MUST be omitted if this was a successful delivery; MAY always be               omitted.             &lt;/dd&gt;              &lt;dt&gt;delivery-echo (aa{sv} - Message_Part[])&lt;/dt&gt;             &lt;dd&gt;               &lt;p&gt;The message content, as defined by the Messages interface.                 Omitted if no content is available. Content MAY have been                 truncated, message parts MAY have been removed, and message                 parts MAY have had their content removed (i.e. the message part                 metadata is present, but the &apos;content&apos; key is not).&lt;/p&gt;                &lt;tp:rationale&gt;                 Some protocols, like XMPP, echo the failing message back to                 the sender. This is sometimes the only way to match it                 against the sent message, so we include it here.               &lt;/tp:rationale&gt;                &lt;p&gt;Unlike in the Messages interface, content not visible                 in the value for this key cannot be retrieved by another                 means, so the connection manager SHOULD be more                 aggressive about including (possibly truncated) message                 content in the &apos;content&apos; key.&lt;/p&gt;                &lt;tp:rationale&gt;                 The Messages interface needs to allow all content to be                 retrieved, but in this interface, the content we provide is                 merely a hint; so some is better than none, and it doesn&apos;t                 seem worth providing an API as complex as Messages&apos;                 GetPendingMessageContent for the echoed message.               &lt;/tp:rationale&gt;             &lt;/dd&gt;            &lt;/dl&gt;            &lt;p&gt;The second and subsequent Message_Part dictionaries, if present,             are a human-readable report from the IM service.&lt;/p&gt;            &lt;p&gt;Clients MUST NOT attempt to send delivery reports using the             SendMessage method in the Messages API, and connection managers             MUST NOT allow this to be done. If support for sending delivery             reports is later added, it will be part of this interface.&lt;/p&gt;            &lt;p&gt;Some example delivery reports in a Python-like syntax (in which             arrays are indicated by [a, b] and dictionaries by {k1: v1, k2: v2})             follow.&lt;/p&gt;            &lt;dl&gt;             &lt;dt&gt;A minimal delivery report indicating permanent failure of the               sent message whose token was               &lt;code&gt;b9a991bd-8845-4d7f-a704-215186f43bb4&lt;/code&gt; for an unknown               reason&lt;/dt&gt;             &lt;dd&gt;&lt;pre&gt; [{ # header &apos;message-sender&apos;: 123, &apos;message-type&apos;: Channel_Text_Message_Type_Delivery_Report, &apos;delivery-status&apos;: Delivery_Status_Permanently_Failed, &apos;delivery-token&apos;: &apos;b9a991bd-8845-4d7f-a704-215186f43bb4&apos;, } # no body ] &lt;/pre&gt;&lt;/dd&gt;              &lt;dt&gt;A delivery report where the failed message is echoed back to the               sender rather than being referenced by ID, and the failure reason               is that this protocol cannot send messages to offline contacts               such as the contact with handle 123&lt;/dt&gt;             &lt;dd&gt;&lt;pre&gt; [{ # header &apos;message-sender&apos;: 123, &apos;message-type&apos;: Channel_Text_Message_Type_Delivery_Report, &apos;delivery-status&apos;: Delivery_Status_Temporarily_Failed, &apos;delivery-error&apos;: Channel_Text_Send_Error_Offline, &apos;delivery-echo&apos;:     [{ # header of original message     &apos;message-sender&apos;: 1,     &apos;message-sent&apos;: 1210067943,     },     { # body of original message     &apos;content-type&apos;: &apos;text/plain&apos;,     &apos;content&apos;: &apos;Hello, world!&apos;,     }]   ],  # no body ] &lt;/pre&gt;&lt;/dd&gt;              &lt;dt&gt;A maximally complex delivery report: the server reports a               bilingual human-readable failure message because the user sent               a message &amp;quot;Hello, world!&amp;quot; with token               &lt;code&gt;b9a991bd-8845-4d7f-a704-215186f43bb4&lt;/code&gt; to a contact               with handle 123, but that handle represents a contact who does not               actually exist&lt;/dt&gt;             &lt;dd&gt;&lt;pre&gt; [{ # header &apos;message-sender&apos;: 123, &apos;message-type&apos;: Channel_Text_Message_Type_Delivery_Report, &apos;delivery-status&apos;: Delivery_Status_Permanently_Failed, &apos;delivery-error&apos;: Channel_Text_Send_Error_Invalid_Contact, &apos;delivery-token&apos;: &apos;b9a991bd-8845-4d7f-a704-215186f43bb4&apos;, &apos;delivery-echo&apos;:     [{ # header of original message     &apos;message-sender&apos;: 1,     &apos;message-sent&apos;: 1210067943,     },     { # body of original message     &apos;content-type&apos;: &apos;text/plain&apos;,     &apos;content&apos;: &apos;Hello, world!&apos;,     }]   ], }, { # message from server (alternative in English) &apos;alternative&apos;: &apos;404&apos;, &apos;content-type&apos;: &apos;text/plain&apos;, &apos;lang&apos;: &apos;en&apos;, &apos;content&apos;: &apos;I have no contact with that name&apos;, }, { # message from server (alternative in German) &apos;alternative&apos;: &apos;404&apos;. &apos;content-type&apos;: &apos;text/plain&apos;, &apos;lang&apos;: &apos;de&apos;, &apos;content&apos;, &apos;Ich habe keinen Kontakt mit diesem Namen&apos;, } ] &lt;/pre&gt;&lt;/dd&gt;              &lt;dt&gt;A minimal delivery report indicating successful delivery               of the sent message whose token was               &lt;code&gt;b9a991bd-8845-4d7f-a704-215186f43bb4&lt;/code&gt;&lt;/dt&gt;             &lt;dd&gt;&lt;pre&gt; [{ # header &apos;message-sender&apos;: 123, &apos;message-type&apos;: Channel_Text_Message_Type_Delivery_Report, &apos;delivery-status&apos;: Delivery_Status_Delivered, &apos;delivery-token&apos;: &apos;b9a991bd-8845-4d7f-a704-215186f43bb4&apos;, } # no body ] &lt;/pre&gt;&lt;/dd&gt;            &lt;/dl&gt;          &lt;/div&gt;
 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GHashTable
 * appropriate for representing a D-Bus
 * dictionary of signature
 * <literal>a{sv}</literal>.
 *
 * Keys (D-Bus type <literal>s</literal>,
 * named <literal>Key</literal>):
 * A key, which SHOULD be one of the well-known keys specified, if           possible.
 *
 * Values (D-Bus type <literal>v</literal>,
 * named <literal>Value</literal>):
 * The value corresponding to the given key, which must be of one of           the types indicated.
 *
 */
#define RTCOM_TP_HASH_TYPE_MESSAGE_PART (rtcom_tp_type_dbus_hash_sv ())

/**
 * RTCOM_TP_HASH_TYPE_MESSAGE_PART_CONTENT_MAP:
 *
 * A mapping from message part indexes to their content, as returned by         &lt;tp:member-ref&gt;GetPendingMessageContent&lt;/tp:member-ref&gt;.
 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GHashTable
 * appropriate for representing a D-Bus
 * dictionary of signature
 * <literal>a{uv}</literal>.
 *
 * Keys (D-Bus type <literal>u</literal>,
 * type <literal>Message_Part_Index</literal>,
 * named <literal>Part</literal>):
 * Indexes into the array of &lt;tp:type&gt;Message_Part&lt;/tp:type&gt;s that           represents a message. The &amp;quot;headers&amp;quot; part (which is not a valid           argument to GetPendingMessageContent) is considered to be part 0,           so the valid part numbers start at 1 (for the second message part).
 *
 * Values (D-Bus type <literal>v</literal>,
 * named <literal>Content</literal>):
 * The message part&apos;s content. The variant MUST contain either type           &apos;s&apos; or &apos;ay&apos; (UTF-8 text string, or byte array), following the           same rules as for the value of the &apos;content&apos; key in           the &lt;tp:type&gt;Message_Part&lt;/tp:type&gt; mappings.
 *
 */
#define RTCOM_TP_HASH_TYPE_MESSAGE_PART_CONTENT_MAP (rtcom_tp_type_dbus_hash_uv ())

GType rtcom_tp_type_dbus_hash_ss (void);

GType rtcom_tp_type_dbus_hash_uv (void);

GType rtcom_tp_type_dbus_hash_sv (void);

GType rtcom_tp_type_dbus_hash_us (void);

GType rtcom_tp_type_dbus_hash_ua_28sasas_29 (void);

/**
 * RTCOM_TP_STRUCT_TYPE_EMERGENCY_SERVICE:

 * (Undocumented)
 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GValueArray
 * appropriate for representing a D-Bus struct
 * with signature <literal>(suas)</literal>.
 *
 * Member 0 (D-Bus type <literal>s</literal>,
 * named <literal>ServiceUrn</literal>):
 * (Undocumented)
 *
 * Member 1 (D-Bus type <literal>u</literal>,
 * named <literal>ServiceHandle</literal>):
 * (Undocumented)
 *
 * Member 2 (D-Bus type <literal>as</literal>,
 * named <literal>AliasList</literal>):
 * (Undocumented)
 *
 */
#define RTCOM_TP_STRUCT_TYPE_EMERGENCY_SERVICE (rtcom_tp_type_dbus_struct_suas ())

/**
 * RTCOM_TP_ARRAY_TYPE_EMERGENCY_SERVICE_LIST:

 * Expands to a call to a function
 * that returns the #GType of a #GPtrArray
 * of #RTCOM_TP_STRUCT_TYPE_EMERGENCY_SERVICE.
 */
#define RTCOM_TP_ARRAY_TYPE_EMERGENCY_SERVICE_LIST (rtcom_tp_type_dbus_array_suas ())

/**
 * RTCOM_TP_STRUCT_TYPE_CONTACT_INFO_FIELD:

 * 
	
          The name of the field; this is the lowercased name of a vCard field.
          For example, a field representing a contact&apos;s address would be named
          &amp;quot;adr&amp;quot;.
        

 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GValueArray
 * appropriate for representing a D-Bus struct
 * with signature <literal>(sasas)</literal>.
 *
 * Member 0 (D-Bus type <literal>s</literal>,
 * named <literal>Field_Name</literal>):
 * The name of the field; this is the lowercased name of a vCard field.           For example, a field representing a contact&apos;s address would be named           &amp;quot;adr&amp;quot;.
 *
 * Member 1 (D-Bus type <literal>as</literal>,
 * named <literal>Parameters</literal>):
 * &lt;tp:docstring xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;           &lt;p&gt;A list of vCard type parameters applicable to this field, with their             values. The type parameter names, and any values that are             case-insensitive in vCard, MUST be in lower case. For example, a             contact&apos;s preferred home address would have parameters             &apos;type=home&apos; and &apos;type=pref&apos;.&lt;/p&gt;            &lt;tp:rationale&gt;             The type parameter &apos;type&apos; is likely to be the most common, but             there can be others, such as &apos;language=en&apos;.           &lt;/tp:rationale&gt;            &lt;p&gt;Characters which are required to be escaped in vCard type             parameters should not be escaped in this list. For instance,             a field &amp;quot;X-FOO;SEMICOLON=\;:bar&amp;quot; in a vCard would become             (&apos;x-foo&apos;, [&apos;semicolon=;&apos;], [&apos;bar&apos;]) in this interface.&lt;/p&gt;            &lt;tp:rationale&gt;             This avoids Telepathy UIs having to understand the escaping and             unescaping rules for vCards. The type parameter name is not             allowed (by RFC 2425) to contain an &apos;=&apos; character, so no ambiguity             is introduced.           &lt;/tp:rationale&gt;
 *
 * Member 2 (D-Bus type <literal>as</literal>,
 * named <literal>Field_Value</literal>):
 * &lt;tp:docstring xmlns=&quot;http://www.w3.org/1999/xhtml&quot;&gt;           &lt;p&gt;For unstructured vCard fields (such as &apos;fn&apos;, a formatted name             field), a single-element array containing the field&apos;s value.&lt;/p&gt;            &lt;p&gt;For structured fields (such as &apos;adr&apos;, an address field), an array             corresponding to the semicolon-separated elements of the field (with             empty strings for empty elements).&lt;/p&gt;            &lt;p&gt;A vCard field with multiple comma-separated values, such as             &apos;nickname&apos;, should be represented by several             &lt;tp:type&gt;Contact_Info_Field&lt;/tp:type&gt;s.&lt;/p&gt;            &lt;p&gt;Characters which are required to be escaped in vCard values, such as             semi-colons and newlines, should not be escaped in this list (e.g. if             a value contains a newline, the data passed over D-Bus should             contain a literal newline character).&lt;/p&gt;            &lt;tp:rationale&gt;             An earlier draft of this interface split structured vCard fields             into multiple Telepathy-level fields; for example, &apos;n&apos; became             &apos;family-name&apos;, &apos;given-name&apos;, etc.  But under this representation,             omitting empty components leads to difficulty identifying where one             name ends and another begins.  Consider the fields [&apos;given-name&apos;,             &apos;honorific-suffixes&apos;, &apos;family-name&apos;, &apos;honorific-prefixes&apos;]: does             this represent two &apos;n&apos; fields, or one with incorrect component             ordering?           &lt;/tp:rationale&gt;
 *
 */
#define RTCOM_TP_STRUCT_TYPE_CONTACT_INFO_FIELD (rtcom_tp_type_dbus_struct_sasas ())

/**
 * RTCOM_TP_ARRAY_TYPE_CONTACT_INFO_FIELD_LIST:

 * Expands to a call to a function
 * that returns the #GType of a #GPtrArray
 * of #RTCOM_TP_STRUCT_TYPE_CONTACT_INFO_FIELD.
 */
#define RTCOM_TP_ARRAY_TYPE_CONTACT_INFO_FIELD_LIST (rtcom_tp_type_dbus_array_sasas ())

/**
 * RTCOM_TP_STRUCT_TYPE_FIELD_SPEC:

 * 
	A struct describing a vCard field, with parameters, that
        may be passed to 
	&lt;tp:member-ref&gt;
		SetContactInfo
	&lt;/tp:member-ref&gt;
	 on this
        Connection.

 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GValueArray
 * appropriate for representing a D-Bus struct
 * with signature <literal>(sasuu)</literal>.
 *
 * Member 0 (D-Bus type <literal>s</literal>,
 * type <literal>VCard_Field</literal>,
 * named <literal>Name</literal>):
 * A vCard field name, such as &apos;tel&apos;.
 *
 * Member 1 (D-Bus type <literal>as</literal>,
 * type <literal>VCard_Type_Parameter[]</literal>,
 * named <literal>Parameters</literal>):
 * The set of vCard type parameters which may be set on this           field. If this list is empty and the           Contact_Info_Field_Flag_Parameters_Mandatory           flag is unset, any vCard type parameters may be used.
 *
 * Member 2 (D-Bus type <literal>u</literal>,
 * type <literal>Contact_Info_Field_Flags</literal>,
 * named <literal>Flags</literal>):
 * Flags describing the behaviour of this           field.
 *
 * Member 3 (D-Bus type <literal>u</literal>,
 * named <literal>Max</literal>):
 * Maximum number of instances of this field which may be           set.  MAXUINT32 is used to indicate that there is no           limit.
 *
 */
#define RTCOM_TP_STRUCT_TYPE_FIELD_SPEC (rtcom_tp_type_dbus_struct_sasuu ())

/**
 * RTCOM_TP_ARRAY_TYPE_FIELD_SPECS:

 * Expands to a call to a function
 * that returns the #GType of a #GPtrArray
 * of #RTCOM_TP_STRUCT_TYPE_FIELD_SPEC.
 */
#define RTCOM_TP_ARRAY_TYPE_FIELD_SPECS (rtcom_tp_type_dbus_array_sasuu ())

/**
 * RTCOM_TP_STRUCT_TYPE_MEMBER_CHANNEL:

 * (Undocumented)
 *
 * This macro expands to a call to a function
 * that returns the #GType of a #GValueArray
 * appropriate for representing a D-Bus struct
 * with signature <literal>(oa{uu})</literal>.
 *
 * Member 0 (D-Bus type <literal>o</literal>,
 * named <literal>Channel</literal>):
 * (Undocumented)
 *
 * Member 1 (D-Bus type <literal>a{uu}</literal>,
 * type <literal>Handle_Owner_Map</literal>,
 * named <literal>Owner_Map</literal>):
 * (Undocumented)
 *
 */
#define RTCOM_TP_STRUCT_TYPE_MEMBER_CHANNEL (rtcom_tp_type_dbus_struct_oa_7buu_7d ())

/**
 * RTCOM_TP_ARRAY_TYPE_MEMBER_CHANNEL_LIST:

 * Expands to a call to a function
 * that returns the #GType of a #GPtrArray
 * of #RTCOM_TP_STRUCT_TYPE_MEMBER_CHANNEL.
 */
#define RTCOM_TP_ARRAY_TYPE_MEMBER_CHANNEL_LIST (rtcom_tp_type_dbus_array_oa_7buu_7d ())

GType rtcom_tp_type_dbus_struct_suas (void);

GType rtcom_tp_type_dbus_struct_oa_7buu_7d (void);

GType rtcom_tp_type_dbus_struct_sasuu (void);

GType rtcom_tp_type_dbus_struct_sasas (void);

GType rtcom_tp_type_dbus_array_suas (void);

GType rtcom_tp_type_dbus_array_oa_7buu_7d (void);

GType rtcom_tp_type_dbus_array_sasuu (void);

GType rtcom_tp_type_dbus_array_sasas (void);

